﻿using System;
using System.Windows.Media.Media3D;

namespace TestProject
{
    /// <summary>
    /// 에지
    /// </summary>
    public class Edge : IEquatable<Edge>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 포인트 1
        /// </summary>
        public Point3D Point1;
        
        /// <summary>
        /// 포인트 2
        /// </summary>
        public Point3D Point2;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - Edge(point1, point2)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="point1">포인트 1</param>
        /// <param name="point2">포인트 2</param>
        public Edge(Point3D point1, Point3D point2)
        {
            Point1 = point1;
            Point2 = point2;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 동일 여부 구하기 - Equals(other)

        /// <summary>
        /// 동일 여부 구하기
        /// </summary>
        /// <param name="other">다른 에지</param>
        /// <returns>동일 여부</returns>
        public bool Equals(Edge other)
        {
            Vector3D vector1 = this.Point1 - other.Point1;
            Vector3D vector2 = this.Point2 - other.Point2;

            if((vector1.Length < 0.001) && (vector2.Length < 0.001))
            {
                return true;
            }

            vector1 = this.Point2 - other.Point1;
            vector2 = this.Point1 - other.Point2;

            if((vector1.Length < 0.001) && (vector2.Length < 0.001))
            {
                return true;
            }

            return false;
        }

        #endregion
    }
}